diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkDecoratorSkyblock.java b/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkDecoratorSkyblock.java
new file mode 100644
index 000000000..b78b7a0ef
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkDecoratorSkyblock.java
@@ -0,0 +1,49 @@
+package net.minecraft.core.world.generate.chunk.skyblock;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.ChestBlockEntity;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.world.generate.chunk.ChunkDecorator;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
+
+import java.util.Random;
+
+public class ChunkDecoratorSkyblock
+    implements ChunkDecorator {
+    @Override
+    public void decorate(Chunk chunk) {
+        // Starting island
+        if (contains(chunk, -1, 1)) {
+            new WorldFeatureTree(Blocks.LEAVES_OAK.id, Blocks.LOG_OAK.id, 6).place(chunk.world, new Random(0), -1, 67, 1);
+        }
+        if (contains(chunk, 4, -3)) {
+            chunk.setBlockIDWithMetadata(4 & (Chunk.CHUNK_SIZE_X - 1), 67, -3 & (Chunk.CHUNK_SIZE_Z - 1), Blocks.CHEST_PLANKS_OAK.id, 3);
+            BlockEntity blockEntity = chunk.getBlockEntity(4 & (Chunk.CHUNK_SIZE_X - 1), 67, -3 & (Chunk.CHUNK_SIZE_Z - 1));
+            if (blockEntity instanceof ChestBlockEntity) {
+                ChestBlockEntity chestEntity = (ChestBlockEntity) blockEntity;
+                chestEntity.setItem(0, new ItemStack(Items.BUCKET_LAVA, 1));
+                chestEntity.setItem(1, new ItemStack(Blocks.ICE, 1));
+            }
+        }
+
+        // Desert island
+        if (contains(chunk, -67, 0)) {
+            chunk.setBlockIDWithMetadata(-67 & (Chunk.CHUNK_SIZE_X - 1), 67, 0 & (Chunk.CHUNK_SIZE_Z - 1), Blocks.CHEST_PLANKS_OAK.id, 1);
+            BlockEntity blockEntity = chunk.getBlockEntity(-67 & (Chunk.CHUNK_SIZE_X - 1), 67, 0 & (Chunk.CHUNK_SIZE_Z - 1));
+            if (blockEntity instanceof ChestBlockEntity) {
+                ChestBlockEntity chestEntity = (ChestBlockEntity) blockEntity;
+                chestEntity.setItem(0, new ItemStack(Blocks.OBSIDIAN, 14));
+                chestEntity.setItem(1, new ItemStack(Items.SEEDS_PUMPKIN, 1));
+            }
+
+        }
+    }
+
+    private boolean contains(Chunk chunk, int xBlock, int zBlock) {
+        return chunk.xPosition == xBlock >> 4 && chunk.zPosition == zBlock >> 4;
+    }
+
+}
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkDecoratorSkyblockNether.java b/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkDecoratorSkyblockNether.java
new file mode 100644
index 000000000..8fac9549e
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkDecoratorSkyblockNether.java
@@ -0,0 +1,51 @@
+package net.minecraft.core.world.generate.chunk.skyblock;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.ChestBlockEntity;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.world.generate.chunk.ChunkDecorator;
+import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
+
+public class ChunkDecoratorSkyblockNether
+    implements ChunkDecorator {
+    @Override
+    public void decorate(Chunk chunk) {
+        // Portal
+        for (int z = 0; z <= 1; z++) {
+            if (contains(chunk, 2, z)) {
+                chunk.setBlockMetadata(2 & (Chunk.CHUNK_SIZE_X - 1), 66, z & (Chunk.CHUNK_SIZE_Z - 1), 1);
+                chunk.setBlockMetadata(2 & (Chunk.CHUNK_SIZE_X - 1), 67, z & (Chunk.CHUNK_SIZE_Z - 1), 1);
+                chunk.setBlockMetadata(2 & (Chunk.CHUNK_SIZE_X - 1), 68, z & (Chunk.CHUNK_SIZE_Z - 1), 1);
+            }
+        }
+
+        // Chest
+        if (contains(chunk, 1, -1)) {
+            chunk.setBlockIDWithMetadata(1 & (Chunk.CHUNK_SIZE_X - 1), 66, -1 & (Chunk.CHUNK_SIZE_Z - 1), Blocks.CHEST_PLANKS_OAK.id, 3);
+            BlockEntity blockEntity = chunk.getBlockEntity(1 & (Chunk.CHUNK_SIZE_X - 1), 66, -1 & (Chunk.CHUNK_SIZE_Z - 1));
+            if (blockEntity != null) {
+                ChestBlockEntity chestBlockEntity = (ChestBlockEntity) blockEntity;
+                chestBlockEntity.setItem(0, new ItemStack(Blocks.SAPLING_BIRCH, 1));
+                chestBlockEntity.setItem(1, new ItemStack(Items.SUGARCANE, 1));
+                chestBlockEntity.setItem(2, new ItemStack(Blocks.ICE, 1));
+            }
+        }
+
+        // Mushrooms
+        tryPlace(chunk, 1, 66, 0, Blocks.MUSHROOM_BROWN.id);
+        tryPlace(chunk, -1, 66, 1, Blocks.MUSHROOM_RED.id);
+    }
+
+    private boolean contains(Chunk chunk, int xBlock, int zBlock) {
+        return chunk.xPosition == xBlock >> 4 && chunk.zPosition == zBlock >> 4;
+    }
+
+    private void tryPlace(Chunk chunk, int xBlock, int yBlock, int zBlock, int blockId) {
+        if (contains(chunk, xBlock, zBlock)) {
+            chunk.setBlockID(xBlock & (Chunk.CHUNK_SIZE_X - 1), yBlock, zBlock & (Chunk.CHUNK_SIZE_Z - 1), blockId);
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblock.java b/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblock.java
new file mode 100644
index 000000000..b5566f80a
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblock.java
@@ -0,0 +1,66 @@
+package net.minecraft.core.world.generate.chunk.skyblock;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.world.generate.chunk.ChunkGenerator;
+import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
+
+public class ChunkGeneratorSkyblock
+    extends ChunkGenerator {
+
+    public ChunkGeneratorSkyblock(World world) {
+        super(world, new ChunkDecoratorSkyblock());
+    }
+
+    @Override
+    protected ChunkGeneratorResult doBlockGeneration(Chunk chunk) {
+        ChunkGeneratorResult result = new ChunkGeneratorResult();
+
+        // Starting island
+        for (int x = -1; x <= 1; x++) {
+            for (int z = -1; z <= 1; z++) {
+                tryPlace(chunk, result, x, 64, z, Blocks.DIRT.id);
+                tryPlace(chunk, result, x, 65, z, Blocks.DIRT.id);
+                tryPlace(chunk, result, x, 66, z, Blocks.GRASS.id);
+            }
+        }
+        for (int x = -1; x <= 1; x++) {
+            for (int z = -4; z <= -2; z++) {
+                tryPlace(chunk, result, x, 64, z, Blocks.DIRT.id);
+                tryPlace(chunk, result, x, 65, z, Blocks.DIRT.id);
+                tryPlace(chunk, result, x, 66, z, Blocks.GRASS.id);
+            }
+        }
+        for (int x = 2; x <= 4; x++) {
+            for (int z = -4; z <= -2; z++) {
+                tryPlace(chunk, result, x, 64, z, Blocks.DIRT.id);
+                tryPlace(chunk, result, x, 65, z, Blocks.DIRT.id);
+                tryPlace(chunk, result, x, 66, z, Blocks.GRASS.id);
+            }
+        }
+        tryPlace(chunk, result, 0, 64, -3, Blocks.BEDROCK.id);
+
+        // Desert island
+        for (int x = -68; x <= -66; x++) {
+            for (int z = -1; z <= 1; z++) {
+                tryPlace(chunk, result, x, 64, z, Blocks.SAND.id);
+                tryPlace(chunk, result, x, 65, z, Blocks.SAND.id);
+                tryPlace(chunk, result, x, 66, z, Blocks.SAND.id);
+            }
+        }
+        tryPlace(chunk, result, -68, 67, 1, Blocks.CACTUS.id);
+
+        return result;
+    }
+
+    private boolean contains(Chunk chunk, int xBlock, int zBlock) {
+        return chunk.xPosition == xBlock >> 4 && chunk.zPosition == zBlock >> 4;
+    }
+
+    private void tryPlace(Chunk chunk, ChunkGeneratorResult result, int xBlock, int yBlock, int zBlock, int blockId) {
+        if (contains(chunk, xBlock, zBlock)) {
+            result.setBlock(xBlock & (Chunk.CHUNK_SIZE_X - 1), yBlock, zBlock & (Chunk.CHUNK_SIZE_Z - 1), blockId);
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblockNether.java b/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblockNether.java
new file mode 100644
index 000000000..ae6bc8bc7
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblockNether.java
@@ -0,0 +1,58 @@
+package net.minecraft.core.world.generate.chunk.skyblock;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.world.generate.chunk.ChunkDecorator;
+import net.minecraft.core.world.generate.chunk.ChunkGenerator;
+import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
+
+public class ChunkGeneratorSkyblockNether
+    extends ChunkGenerator {
+
+    public ChunkGeneratorSkyblockNether(World world) {
+        super(world, new ChunkDecoratorSkyblockNether());
+    }
+
+    @Override
+    protected ChunkGeneratorResult doBlockGeneration(Chunk chunk) {
+        ChunkGeneratorResult result = new ChunkGeneratorResult();
+
+        // Main island
+        for (int x = -1; x <= 1; x++) {
+            for (int z = -1; z <= 1; z++) {
+                tryPlace(chunk, result, x, 63, z, Blocks.GLOWSTONE.id);
+                tryPlace(chunk, result, x, 64, z, Blocks.GLOWSTONE.id);
+                tryPlace(chunk, result, x, 65, z, Blocks.GLOWSTONE.id);
+            }
+        }
+        // Portal
+        for (int z = -1; z <= 2; z++) {
+            if (z == -1 || z == 2) {
+                tryPlace(chunk, result, 2, 65, z, Blocks.OBSIDIAN.id);
+                tryPlace(chunk, result, 2, 66, z, Blocks.OBSIDIAN.id);
+                tryPlace(chunk, result, 2, 67, z, Blocks.OBSIDIAN.id);
+                tryPlace(chunk, result, 2, 68, z, Blocks.OBSIDIAN.id);
+                tryPlace(chunk, result, 2, 69, z, Blocks.OBSIDIAN.id);
+            } else {
+                tryPlace(chunk, result, 2, 65, z, Blocks.OBSIDIAN.id);
+                tryPlace(chunk, result, 2, 66, z, Blocks.PORTAL_NETHER.id);
+                tryPlace(chunk, result, 2, 67, z, Blocks.PORTAL_NETHER.id);
+                tryPlace(chunk, result, 2, 68, z, Blocks.PORTAL_NETHER.id);
+                tryPlace(chunk, result, 2, 69, z, Blocks.OBSIDIAN.id);
+            }
+        }
+
+        return result;
+    }
+
+    private boolean contains(Chunk chunk, int xBlock, int zBlock) {
+        return chunk.xPosition == xBlock >> 4 && chunk.zPosition == zBlock >> 4;
+    }
+
+    private void tryPlace(Chunk chunk, ChunkGeneratorResult result, int xBlock, int yBlock, int zBlock, int blockId) {
+        if (contains(chunk, xBlock, zBlock)) {
+            result.setBlock(xBlock & (Chunk.CHUNK_SIZE_X - 1), yBlock, zBlock & (Chunk.CHUNK_SIZE_Z - 1), blockId);
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeature.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeature.java
index 7cb04ce7e..1428331ae 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeature.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeature.java
@@ -14,9 +14,9 @@ public abstract class WorldFeature
     {
     }
 
-    public abstract boolean generate(World world, Random random, int x, int y, int z);
+    public abstract boolean place(World world, Random random, int x, int y, int z);
 
-    public void func_517_a(double d, double d1, double d2)
+    public void init(double d, double d1, double d2)
     {
     }
 }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureAlgae.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureAlgae.java
index 328b1418f..e84fc53c0 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureAlgae.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureAlgae.java
@@ -1,29 +1,30 @@
 package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            WorldGenerator, World, Block, BlockFlower
+//            WorldGenerator, World, Block, FlowerBlock
 
 public class WorldFeatureAlgae extends WorldFeature
 {
 
     @Override
-    public boolean generate(World world, Random random, int x, int y, int z)
+    public boolean place(World world, Random random, int x, int y, int z)
     {
         for(int l = 0; l < 128; l++)
         {
             int i1 = (x + random.nextInt(8)) - random.nextInt(8);
             int j1 = (y);
             int k1 = (z + random.nextInt(8)) - random.nextInt(8);
-            if((world.getBlockId(i1, j1, k1) == Block.fluidWaterStill.id) &&
+            if((world.getBlockId(i1, j1, k1) == Blocks.FLUID_WATER_STILL.id) &&
                     world.getBlockMaterial(i1, j1+1, k1) == Material.air)
             {
-                world.setBlock(i1, j1+1, k1, Block.algae.id);
+                world.setBlock(i1, j1+1, k1, Blocks.ALGAE.id);
             }
         }
 
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureCactus.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureCactus.java
index f2799a33a..cdc4fc961 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureCactus.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureCactus.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
@@ -16,7 +17,7 @@ public class WorldFeatureCactus extends WorldFeature
     }
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
         for(int l = 0; l < 10; l++)
         {
@@ -30,9 +31,9 @@ public class WorldFeatureCactus extends WorldFeature
             int l1 = 1 + random.nextInt(random.nextInt(3) + 1);
             for(int i2 = 0; i2 < l1; i2++)
             {
-                if(Block.cactus.canBlockStay(world, i1, j1 + i2, k1))
+                if(Blocks.CACTUS.canBlockStay(world, i1, j1 + i2, k1))
                 {
-                    world.setBlock(i1, j1 + i2, k1, Block.cactus.id);
+                    world.setBlock(i1, j1 + i2, k1, Blocks.CACTUS.id);
                 }
             }
 
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureClay.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureClay.java
index 8e90a8c70..26f5a7f82 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureClay.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureClay.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
@@ -13,25 +14,25 @@ import java.util.Random;
 
 public class WorldFeatureClay extends WorldFeature
 {	public WorldFeatureClay(int numberOfBlocks) {
-		this(numberOfBlocks, Block.sand);
+		this(numberOfBlocks, Blocks.SAND);
 	}
 
     @MethodParametersAnnotation(names = {"numberOfBlocks", "block"})
     public WorldFeatureClay(int numberOfBlocks, Block block)
     {
-        clayBlockId = Block.blockClay.id;
+        clayBlockId = Blocks.BLOCK_CLAY.id;
         this.numberOfBlocks = numberOfBlocks;
         this.generateInId = block.id;
     }
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
         if(world.getBlockMaterial(x, y, z) != Material.water)
         {
             return false;
         }
-        float f = random.nextFloat() * 3.141593F;
+        float f = random.nextFloat() * MathHelper.PI;
         double d = (float)(x + 8) + (MathHelper.sin(f) * (float)numberOfBlocks) / 8F;
         double d1 = (float)(x + 8) - (MathHelper.sin(f) * (float)numberOfBlocks) / 8F;
         double d2 = (float)(z + 8) + (MathHelper.cos(f) * (float)numberOfBlocks) / 8F;
@@ -44,14 +45,14 @@ public class WorldFeatureClay extends WorldFeature
             double d7 = d4 + ((d5 - d4) * (double)l) / (double)numberOfBlocks;
             double d8 = d2 + ((d3 - d2) * (double)l) / (double)numberOfBlocks;
             double d9 = (random.nextDouble() * (double)numberOfBlocks) / 16D;
-            double d10 = (double)(MathHelper.sin(((float)l * 3.141593F) / (float)numberOfBlocks) + 1.0F) * d9 + 1.0D;
-            double d11 = (double)(MathHelper.sin(((float)l * 3.141593F) / (float)numberOfBlocks) + 1.0F) * d9 + 1.0D;
-            int i1 = MathHelper.floor_double(d6 - d10 / 2D);
-            int j1 = MathHelper.floor_double(d7 - d11 / 2D);
-            int k1 = MathHelper.floor_double(d8 - d10 / 2D);
-            int l1 = MathHelper.floor_double(d6 + d10 / 2D);
-            int i2 = MathHelper.floor_double(d7 + d11 / 2D);
-            int j2 = MathHelper.floor_double(d8 + d10 / 2D);
+            double d10 = (double)(MathHelper.sin(((float)l * MathHelper.PI) / (float)numberOfBlocks) + 1.0F) * d9 + 1.0D;
+            double d11 = (double)(MathHelper.sin(((float)l * MathHelper.PI) / (float)numberOfBlocks) + 1.0F) * d9 + 1.0D;
+            int i1 = MathHelper.floor(d6 - d10 / 2D);
+            int j1 = MathHelper.floor(d7 - d11 / 2D);
+            int k1 = MathHelper.floor(d8 - d10 / 2D);
+            int l1 = MathHelper.floor(d6 + d10 / 2D);
+            int i2 = MathHelper.floor(d7 + d11 / 2D);
+            int j2 = MathHelper.floor(d8 + d10 / 2D);
             for(int k2 = i1; k2 <= l1; k2++)
             {
                 double d12 = (((double)k2 + 0.5D) - d6) / (d10 / 2D);
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDeadBush.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDeadBush.java
index 0686b8a7a..a4f341063 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDeadBush.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDeadBush.java
@@ -1,14 +1,14 @@
 package net.minecraft.core.world.generate.feature;
 
+import net.minecraft.core.block.BaseLeavesBlock;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLeavesBase;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            WorldGenerator, World, Block, BlockLeaves, 
-//            BlockFlower
+//            FlowerBlock
 
 public class WorldFeatureDeadBush extends WorldFeature
 {
@@ -20,9 +20,9 @@ public class WorldFeatureDeadBush extends WorldFeature
     }
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
-        for(int l = 0; ((l = world.getBlockId(x, y, z)) == 0 || Block.blocksList[l] instanceof BlockLeavesBase) && y > 0; y--) { }
+        for(int l = 0; ((l = world.getBlockId(x, y, z)) == 0 || Block.blocksList[l] instanceof BaseLeavesBlock) && y > 0; y--) { }
         for(int i1 = 0; i1 < 4; i1++)
         {
             int j1 = (x + random.nextInt(8)) - random.nextInt(8);
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDungeon.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDungeon.java
index ce0c56b13..4a48328e6 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDungeon.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDungeon.java
@@ -2,19 +2,20 @@ package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.WeightedRandomBag;
 import net.minecraft.core.WeightedRandomLootObject;
+import net.minecraft.core.block.entity.ChestBlockEntity;
+import net.minecraft.core.block.entity.MobSpawnerBlockEntity;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.entity.TileEntityChest;
-import net.minecraft.core.block.entity.TileEntityMobSpawner;
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.Material;
 
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            WorldGenerator, World, Material, Block, 
-//            TileEntityChest, TileEntityMobSpawner, ItemStack, Item
+//            ChestBlockEntity, MobSpawnerBlockEntity, ItemStack, Item
 
 public class WorldFeatureDungeon extends WorldFeature
 {
@@ -31,22 +32,22 @@ public class WorldFeatureDungeon extends WorldFeature
     	this.blockIdFloor = blockIdFloor;
     	this.mobOverride = mobOverride;
         this.chestLoot = new WeightedRandomBag<>();
-        chestLoot.addEntry(new WeightedRandomLootObject(Item.saddle.getDefaultStack()), 100);
-        chestLoot.addEntry(new WeightedRandomLootObject(Item.ingotIron.getDefaultStack(), 1, 4), 100);
-        chestLoot.addEntry(new WeightedRandomLootObject(Item.foodBread.getDefaultStack()), 100);
-        chestLoot.addEntry(new WeightedRandomLootObject(Item.wheat.getDefaultStack(), 1, 4), 100);
-        chestLoot.addEntry(new WeightedRandomLootObject(Item.sulphur.getDefaultStack(), 1, 4), 100);
-        chestLoot.addEntry(new WeightedRandomLootObject(Item.string.getDefaultStack(), 1, 4), 100);
-        chestLoot.addEntry(new WeightedRandomLootObject(Item.bucket.getDefaultStack()), 100);
-        chestLoot.addEntry(new WeightedRandomLootObject(Item.foodAppleGold.getDefaultStack()), 1);
-        chestLoot.addEntry(new WeightedRandomLootObject(Item.dustRedstone.getDefaultStack(), 1, 4), 50);
+        chestLoot.addEntry(new WeightedRandomLootObject(Items.SADDLE.getDefaultStack()), 100);
+        chestLoot.addEntry(new WeightedRandomLootObject(Items.INGOT_IRON.getDefaultStack(), 1, 4), 100);
+        chestLoot.addEntry(new WeightedRandomLootObject(Items.FOOD_BREAD.getDefaultStack()), 100);
+        chestLoot.addEntry(new WeightedRandomLootObject(Items.WHEAT.getDefaultStack(), 1, 4), 100);
+        chestLoot.addEntry(new WeightedRandomLootObject(Items.SULPHUR.getDefaultStack(), 1, 4), 100);
+        chestLoot.addEntry(new WeightedRandomLootObject(Items.STRING.getDefaultStack(), 1, 4), 100);
+        chestLoot.addEntry(new WeightedRandomLootObject(Items.BUCKET.getDefaultStack()), 100);
+        chestLoot.addEntry(new WeightedRandomLootObject(Items.FOOD_APPLE_GOLD.getDefaultStack()), 1);
+        chestLoot.addEntry(new WeightedRandomLootObject(Items.DUST_REDSTONE.getDefaultStack(), 1, 4), 50);
         for (int i = 0; i < 9; i++) {
-            chestLoot.addEntry(new WeightedRandomLootObject(new ItemStack(Item.itemsList[Item.record13.id + i]), 1), 1);
+            chestLoot.addEntry(new WeightedRandomLootObject(new ItemStack(Item.itemsList[Items.RECORD_13.id + i]), 1), 1);
         }
-        chestLoot.addEntry(new WeightedRandomLootObject(Block.saplingCacao.getDefaultStack()), 100);
-        chestLoot.addEntry(new WeightedRandomLootObject(Block.spongeDry.getDefaultStack(), 1, 4), 100);
-        chestLoot.addEntry(new WeightedRandomLootObject(Item.bone.getDefaultStack(), 1, 4), 100);
-        chestLoot.addEntry(new WeightedRandomLootObject(Item.foodApple.getDefaultStack()), 100);
+        chestLoot.addEntry(new WeightedRandomLootObject(Blocks.SAPLING_CACAO.getDefaultStack()), 100);
+        chestLoot.addEntry(new WeightedRandomLootObject(Blocks.SPONGE_DRY.getDefaultStack(), 1, 4), 100);
+        chestLoot.addEntry(new WeightedRandomLootObject(Items.BONE.getDefaultStack(), 1, 4), 100);
+        chestLoot.addEntry(new WeightedRandomLootObject(Items.FOOD_APPLE.getDefaultStack()), 100);
         chestLoot.addEntry(new WeightedRandomLootObject(null),239);
 
         this.spawnerMonsters = new WeightedRandomBag<>();
@@ -56,7 +57,7 @@ public class WorldFeatureDungeon extends WorldFeature
     }
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
         byte height = 3;
         int width = random.nextInt(2) + 2;
@@ -156,8 +157,8 @@ public class WorldFeatureDungeon extends WorldFeature
                 {
                     continue;
                 }
-                world.setBlockWithNotify(k3, l3, i4, Block.chestPlanksOak.id);
-                TileEntityChest tileentitychest = (TileEntityChest)world.getBlockTileEntity(k3, l3, i4);
+                world.setBlockWithNotify(k3, l3, i4, Blocks.CHEST_PLANKS_OAK.id);
+                ChestBlockEntity tileentitychest = (ChestBlockEntity)world.getBlockEntity(k3, l3, i4);
                 int k4 = 0;
                 do
                 {
@@ -168,7 +169,7 @@ public class WorldFeatureDungeon extends WorldFeature
                     ItemStack itemstack = pickCheckLootItem(random);
                     if(itemstack != null)
                     {
-                        tileentitychest.setInventorySlotContents(random.nextInt(tileentitychest.getSizeInventory()), itemstack);
+                        tileentitychest.setItem(random.nextInt(tileentitychest.getContainerSize()), itemstack);
                     }
                     k4++;
                 } while(true);
@@ -176,8 +177,8 @@ public class WorldFeatureDungeon extends WorldFeature
 
         }
 
-        world.setBlockWithNotify(x, y, z, Block.mobspawner.id);
-        TileEntityMobSpawner tileentitymobspawner = (TileEntityMobSpawner)world.getBlockTileEntity(x, y, z);
+        world.setBlockWithNotify(x, y, z, Blocks.MOBSPAWNER.id);
+        MobSpawnerBlockEntity tileentitymobspawner = (MobSpawnerBlockEntity)world.getBlockEntity(x, y, z);
         tileentitymobspawner.setMobId(pickMobSpawner(random));
         return true;
     }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFire.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFire.java
index c30984ae6..20f4e14f8 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFire.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFire.java
@@ -1,12 +1,13 @@
 package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            WorldGenerator, World, Block, BlockFire
+//            WorldGenerator, World, Block, FireBlock
 
 public class WorldFeatureFire extends WorldFeature
 {
@@ -16,16 +17,16 @@ public class WorldFeatureFire extends WorldFeature
     }
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
         for(int l = 0; l < 64; l++)
         {
             int i1 = (x + random.nextInt(8)) - random.nextInt(8);
             int j1 = (y + random.nextInt(4)) - random.nextInt(4);
             int k1 = (z + random.nextInt(8)) - random.nextInt(8);
-            if(world.isAirBlock(i1, j1, k1) && world.getBlockId(i1, j1 - 1, k1) == Block.netherrack.id)
+            if(world.isAirBlock(i1, j1, k1) && world.getBlockId(i1, j1 - 1, k1) == Blocks.NETHERRACK.id)
             {
-                world.setBlockWithNotify(i1, j1, k1, Block.fire.id);
+                world.setBlockWithNotify(i1, j1, k1, Blocks.FIRE.id);
             }
         }
 
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFlowers.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFlowers.java
index 98053cc51..e2081c41b 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFlowers.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFlowers.java
@@ -1,12 +1,13 @@
 package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            WorldGenerator, World, Block, BlockFlower
+//            WorldGenerator, World, Block, FlowerBlock
 
 public class WorldFeatureFlowers extends WorldFeature
 {
@@ -18,7 +19,7 @@ public class WorldFeatureFlowers extends WorldFeature
     }
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
         for(int l = 0; l < 64; l++)
         {
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstoneA.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstoneA.java
index b6ef57781..39760661e 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstoneA.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstoneA.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
@@ -16,17 +17,17 @@ public class WorldFeatureGlowstoneA extends WorldFeature
     }
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
         if(!world.isAirBlock(x, y, z))
         {
             return false;
         }
-        if(world.getBlockId(x, y + 1, z) != Block.netherrack.id)
+        if(world.getBlockId(x, y + 1, z) != Blocks.NETHERRACK.id)
         {
             return false;
         }
-        world.setBlockWithNotify(x, y, z, Block.glowstone.id);
+        world.setBlockWithNotify(x, y, z, Blocks.GLOWSTONE.id);
         for(int l = 0; l < 1500; l++)
         {
             int i1 = (x + random.nextInt(8)) - random.nextInt(8);
@@ -64,7 +65,7 @@ public class WorldFeatureGlowstoneA extends WorldFeature
                 {
                     j2 = world.getBlockId(i1, j1, k1 + 1);
                 }
-                if(j2 == Block.glowstone.id)
+                if(j2 == Blocks.GLOWSTONE.id)
                 {
                     l1++;
                 }
@@ -72,7 +73,7 @@ public class WorldFeatureGlowstoneA extends WorldFeature
 
             if(l1 == 1)
             {
-                world.setBlockWithNotify(i1, j1, k1, Block.glowstone.id);
+                world.setBlockWithNotify(i1, j1, k1, Blocks.GLOWSTONE.id);
             }
         }
 
